MODULE Sortierverfahren
    IMPLICIT NONE

CONTAINS

SUBROUTINE SelectionSort(Feld,counter)
	INTEGER,DIMENSION(:):: Feld
	INTEGER::counter, minpos, swap, i,j,n
	
	n=SIZE(Feld)
	counter=1
	DO i=1,n-1
		minpos=i
		counter=counter+1
		DO j=i+1,n
			IF (Feld(j)<Feld(minpos)) THEN
				minpos=j
				counter=counter+1
			END IF
			counter=counter+1
		END DO
		IF (minpos /= i) THEN
			swap=Feld(i)
			Feld(i)=Feld(minpos)
			Feld(minpos) = swap
			counter=counter+3
		END IF
		counter=counter+1
	END DO
END SUBROUTINE

SUBROUTINE BubbleSort(Feld,counter)
	INTEGER,DIMENSION(:):: Feld
	INTEGER:: counter, i,n,swap,lastswap		
		
	n=SIZE(Feld)
	counter=1
	DO WHILE(n>1)
		lastswap=1
		counter=counter+2
		DO i=1,n-1
			IF (Feld(i+1)<Feld(i)) THEN
				swap=Feld(i)
				Feld(i)=Feld(i+1)
				Feld(i+1)=swap
				lastswap=i
				counter=counter+4
			END IF
			counter=counter+1
		END DO
		n=lastswap
		counter=counter+1
	END DO
END SUBROUTINE
END MODULE

PROGRAM TestSort
USE Sortierverfahren
IMPLICIT NONE

INTEGER,DIMENSION(10)::A,D
INTEGER,DIMENSION(100)::B
INTEGER::c,i
REAL::r

	WRITE(*,*) 'Bereits sortiertes Feld'
	WRITE(*,*)
	A=(/(i,i=1,10)/)
	WRITE(*,'(A,1X,10I3.1,1X,A)') 'Sortiere', A, 'mittels Selectionsort:'
	CALL SelectionSort(A,c)
	WRITE(*,'(10X,10I3.1)') A
	WRITE(*,*) c, 'Schritte wurden benötigt'
	A=(/(i,i=1,10)/)
	WRITE(*,'(A,1X,10I3.1,1X,A)') 'Sortiere', A, 'mittels Bubblesort:'
	CALL BubbleSort(A,c)
	WRITE(*,'(10X,10I3.1)') A
	WRITE(*,*) c, 'Schritte wurden benötigt'
	WRITE(*,*)
	WRITE(*,*) 'Rückwärts sortiertes Feld'
	WRITE(*,*)
	A=(/(i,i=10,1,-1)/)
	WRITE(*,'(A,1X,10I3.1,1X,A)') 'Sortiere', A, 'mittels Selectionsort:'
	CALL SelectionSort(A,c)
	WRITE(*,'(10X,10I3.1)') A
	WRITE(*,*) c, 'Schritte wurden benötigt'
	A=(/(i,i=10,1,-1)/)
	WRITE(*,'(A,1X,10I3.1,1X,A)') 'Sortiere', A, 'mittels Bubblesort:'
	CALL BubbleSort(A,c)
	WRITE(*,'(10X,10I3.1)') A
	WRITE(*,*) c, 'Schritte wurden benötigt'
	WRITE(*,*)
	WRITE(*,*) 'Zufälliges Feld'
	WRITE(*,*)
	DO i=1,10
		CALL Random_Number(r)
		A(i)=int(100*r)
		D(i)=A(i)
	END DO
	WRITE(*,'(A,1X,10I3.1,1X,A)') 'Sortiere', A, 'mittels Selectionsort:'
	CALL SelectionSort(A,c)
	WRITE(*,'(10X,10I3.1)') A
	WRITE(*,*) c, 'Schritte wurden benötigt'
	WRITE(*,'(A,1X,10I3.1,1X,A)') 'Sortiere', D, 'mittels Bubblesort:'
	CALL BubbleSort(D,c)
	WRITE(*,'(10X,10I3.1)') D
	WRITE(*,*) c, 'Schritte wurden benötigt'
END PROGRAM
