PROGRAM schaltjahre
  IMPLICIT NONE

  INTEGER :: a
  LOGICAL :: j

  WRITE(*,*) "Gib eine Jahreszahl ein!"
  READ(*,*) a

  IF(MOD(a,4)==0) THEN        !Ist die Jahreszahl durch 4 teilbar?
    IF(MOD(a,100)==0) THEN    !Ist die Jahreszahl durch 100 teilbar?
      IF(MOD(a,400)==0) THEN  !Ist die Jahreszahl durch 400 teilbar?
        j = .TRUE.            !Dann ist es ein Schaltjahr (weil durch 4, 100 und 400 teilbar)
        !Teste diesen Fall z.B. mit a = 4000
      ELSE
        j = .FALSE.           !Sonst ist es kein Schaltjahr (weil durch 4 und 100, aber nicht durch 400 teilbar)
        !Teste diesen Fall z.B. mit a = 3000
      END IF
    ELSE
      j = .TRUE.              !Es ist ein Schaltjahr (weil durch 4, aber nicht durch 100 teilbar)
      !Teste diesen Fall z.B. mit a = 2004
    END IF
  ELSE
    j = .FALSE.               !Es ist keins (weil nicht durch 4 teilbar)
    !Teste diesen Fall z.B. mit a = 2001
  END IF

  !ALTERNATIV (Zusatzaufgabe):
  !j = (MOD(a,4)==0.AND..NOT.MOD(a,100)==0).OR.MOD(a,400)==0

  IF(j) THEN
    WRITE(*,*) a, " ist ein Schaltjahr."
  ELSE
    WRITE(*,*) a, " ist kein Schaltjahr."
  END IF

END PROGRAM schaltjahre
