PROGRAM taschenrechner
  IMPLICIT NONE

  !Lege Speicherplatz für Variablen an
  REAL :: a, b
  CHARACTER :: op,weiter

  DO 
    !Gib dem Benutzer bescheid, was er tun soll:
    WRITE(*,*) 'Bitte gib zwei Zahlen ein.'

   !Lies über die Tastatur zwei Zahlen ein:
    READ(*,*) a, b
  
    !Abfrage, welche Rechneoperation durchgeführt werden soll
    WRITE(*,*) 'Gib bitte die gewünschte Rechenoperation ein: '
    WRITE(*,*) 'a für Addition, s für Subtraktion, m für Multiplikation, d für Division'
    READ(*,*) op
  
    IF(op=='a') THEN 
      WRITE(*,*) 'Das Ergebnis von ',a,' plus ',b,' ist: ', a+b
    ELSE IF(op=='s') THEN 
      WRITE(*,*) 'Das Ergebnis von ',a,' minus ',b,' ist: ', a-b
    ELSE IF(op=='m') THEN 
      WRITE(*,*) 'Das Ergebnis von ',a,' mal ',b,' ist: ', a*b
    ELSE IF(op=='d' .AND. b/=0) THEN 
      WRITE(*,*) 'Das Ergebnis von ',a,' durch ',b,' ist: ', a/b
    ELSE 
      WRITE(*,*) 'Die Eingabe war nicht gültig!'
    END IF 
	!Alternativ kann man zum Beispiel auch eine Ergebnisvariable anlegen, in die in den 
	!unterschiedlichen Fällen das Ergebnis gespeichert wird, und dann nach der 
	!IF-Verzweigung den Inhalt der Variable ausgeben. 
	
	WRITE(*,*) 'Möchtest du weiter rechnen? (Gib n für nein ein)'
	READ(*,*) weiter  !es muss auch keine extra Variable angelegt werden, Speicherung in op auch möglich
	IF(weiter=='n') EXIT 
	
  END DO 
  
  !Alternative mit Select Case 
  
  WRITE(*,*) 'Bitte gib zwei Zahlen ein.'
  READ(*,*) a, b
  WRITE(*,*) 'Gib bitte die gewünschte Rechenoperation ein: '
  WRITE(*,*) 'a für Addition, s für Subtraktion, m für Multiplikation, d für Division'
  READ(*,*) op
  
  SELECT CASE (op)
    CASE ('a')
	  WRITE(*,*) 'Das Ergebnis von ',a,' plus ',b,' ist: ', a+b
	CASE ('s')
	  WRITE(*,*) 'Das Ergebnis von ',a,' minus ',b,' ist: ', a-b
	CASE ('m')
	  WRITE(*,*) 'Das Ergebnis von ',a,' mal ',b,' ist: ', a*b
	CASE ('d')
	  IF(b/=0) THEN 
	    WRITE(*,*) 'Das Ergebnis von ',a,' durch ',b,' ist: ', a/b
	  ELSE 
	    WRITE(*,*) 'Durch Null darf nicht geteilt werden!'
	  END IF 
	CASE DEFAULT 
	  WRITE(*,*) 'Die Eingabe war nicht gültig!'
  END SELECT
  

END PROGRAM
