program pointer_exercise
    implicit none
    
    ! Declare variables
    integer, target  :: a = 5
    integer, pointer :: ptr
    
    ! Point ptr to variable a
        ptr => a
    
    ! Modify the value of a using ptr
        ptr = ptr + 10
    
    ! Print the modified value of a
        write(*,*) "The modified value of a is:", a
    
end program pointer_exercise

program pointer_exercise_2
    implicit none
    
    type ListElement
        integer                     :: element 
        type(ListElement), pointer  :: next => null()
    end type ListElement

    type List !(für Kinderreim Hausaufgabe nicht notwendig!)
        type(ListElement), pointer  :: head => null()
    end type List


    type(List):: myList

    !Allocate storage for the first (head) element of the list
        allocate(myList%head)
    
    !Insert the number 1 as the first (head) element of the list
        myList%head%element = 1

    !Allocate storage for the second element of the list
        allocate(myList%head%next)
    
    !Insert the number 2 as the second element of the list
        myList%head%next%element = 2

    !Write the first and second element of the list
        write(*,*)myList%head%element, myList%head%next%element
    
    !Deallocate the second element of the list
        deallocate(myList%head%next)
    
    !Verify that there is no second element in the list using associated()
        write(*,*)associated(myList%head%next)
    
    !Try writing the first and second element of the list again
        write(*,*)myList%head%element, myList%head%next%element
    
    !Try writing a hypthetical third element of the list
        !write(*,*)myList%head%next%next%element
    
    !Deallocate the first element of the list
        deallocate(myList%head)

end program pointer_exercise_2



program pointer_exercise_3
    implicit none
    
    type ListElement
        integer                     :: element 
        type(ListElement), pointer  :: next => null()
    end type ListElement

    type List
        type(ListElement), pointer  :: head => null()
    end type List

    type(List)                  :: myList
    type(ListElement),pointer   :: current
    integer                     :: input

    allocate(myList%head)
    write(*,*) "Please enter the integer of the first element of the List:"
    read(*,*) myList%head%element
    current => myList%head

    !Write a do loop that inserts new integers given by the user into the List until the user inputs a negative number.
    !Use the pointer "current" and the integer "input"  
        do 
            write(*,*) "Please enter the next integer of the List, enter a negative integer to stop:"
            read(*,*) input
            if(input < 0) exit

            allocate(current%next)
            current%next%element = input
            
            current => current%next
        end do
    
    !Deallocate the list element by element.


end program pointer_exercise_3




